unit ReleUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, CPort, CPortCtl;



type

ResType = (rtInputsOn,rtInputsOff,rtAlarmRun,rtAlarmStop,rtResetMode,rtRespondMode,rtButtonState,rtTimeOut,rtNoAlert,rtAlert,rtUnknown);
CmdType = (ctRelaySet,ctRelayTimeOut,ctAlarmRun,ctAlarmStop,ctResetMode,ctRespondMode,ctRequestInputs,ctUnknown);

tmKind  = (mCmd,mRespond,mFailture);

TRele = class

        ComPort : TComPort;

        Relays : array [1..6] of boolean ;
        Inputs : array [1..6] of boolean;

        AlarmState : boolean;
        AlertState : boolean;
        ResetMode  : boolean;
        RespondMode  : boolean;

        MsgRichEdit : TRichEdit;


        procedure OnAlert(InputNumber : integer);
        procedure TextOut(Msg : string; mKind : tmKind);

        procedure ShowSetupDialog;
        function  ConnectOnPort(PortName : string) : boolean;


        function ProcessRespond(Cmd : string) : ResType;
        function ProcessCmd(Cmd : string) : CmdType;



           function SwichRelays(R1,R2,R3,Delay : integer; TurnOnOff: boolean): string; // vrac "" kdy failne
           function CallOnInputStop(Call : boolean): string;
           function CallOnTimer(Call : boolean): string;
           function RunAlarm:  string;
           function StopAlarm: string;
           function GetInputs : string;
           function GetArmedInputs : string;


        constructor Create(MsgR : TRichEdit; SharedComPort : TComPort);
        destructor Destroy;

   end;

implementation

constructor TRele.Create(MsgR : TRichEdit; SharedComPort : TComPort);
var i : integer;
begin


   MsgRichEdit := MsgR;

   if SharedComPort <> nil then ComPort := SharedComPort;



        for i:=1 to 6 do begin
               Relays[i] := false;
               Inputs[i] := false;
             end;

        AlarmState  := true;
        AlertState  := false;
        ResetMode   := false;
        RespondMode := false;



end;


Destructor TRele.Destroy;
begin

  inherited Destroy;

end;


procedure TRele.TextOut(Msg : string; mKind : tmKind);
var
aColor : TColor;
begin

    case mKind of
       mCmd :  begin
                  aColor := clBlue;
                  Msg := 'CMD >' + Msg;
               end;
       mRespond :  begin
                  aColor := clMaroon;
                  Msg := 'IO  >' + Msg;
               end;
       mFailture :  begin
                  aColor := clRed;
                  Msg := 'ERR >' + Msg;
               end;
      end;

  try
   if MsgRichEdit <> nil then
   with MsgRichEdit do begin
    SelStart := 0;
    SelLength :=0;
    SelAttributes.Color := aColor;
    SelText := Msg + #13#10;
   end;
  except ShowMessage('ERROR - unable to write to RichText box'); end;





end;


function TRele.ProcessCmd(Cmd : string) : CmdType;
var
i,CmdPos : integer;
switch : boolean;
tu,rt,zapvyp,rMsg : string;
TimeOut : integer;

begin
Result := ctUnknown;
TimeOut := 0;
rMsg := '';


 if (Cmd<>'') and (Cmd<>'#fail') and ((Cmd[Length(Cmd)]='s') or (cmd='?') or (cmd='!')) then begin

   if Cmd = 'RUN=1s' then begin
                      rMsg := 'Zapnm alarm...';
                      Result := ctAlarmRun;
                     end else

   if Cmd = 'RUN=0s' then begin
                      rMsg := 'Vypnm alarm...';
                      Result := ctAlarmStop;
                     end else
   if Cmd = 'Rcfg1=1s' then begin
                      rMsg := 'Zapnm funkci "Oznamovn vypren asovae"...';
                      Result := ctResetMode;
                     end else
   if Cmd = 'Rcfg1=0s' then begin
                      rMsg := 'Vypnm funkci "Oznamovn vypren asovae"...';
                      Result := ctResetMode;
                     end else

   if Cmd = 'RESET=Ys' then begin
                      rMsg := 'Zapnm "Oznamovn deaktivace vstup"...';
                      Result := ctResetMode;
                     end else
   if Cmd = 'RESET=Ns' then begin
                      rMsg := 'Vypnm "Oznamovn deaktivace vstup"...';
                      Result := ctResetMode;
                     end else
   if (Cmd[1]='R') and (Cmd[2] in ['1'..'6']) and (Length(Cmd)>4) then begin
             // RELAYS
                try
                     CmdPos := Pos('=',Cmd);

                     if Cmd[Length(Cmd)-1] = '1' then begin
                                            switch := true; zapvyp := ' zapnut ';
                                            end else begin
                                            switch := false; zapvyp := ' vypnut ';
                                            end;
                     tu := Copy(Cmd,CmdPos+1,Length(Cmd)-CmdPos-3); // timeout
                     if tu <> '' then TimeOut := strtoint(tu);


                     rt := '';
                     for i := 2 to CmdPos-1 do begin if Cmd[i] in ['1'..'6'] then Relays[strtoint(Cmd[i])] := switch; rt :=rt+','+Cmd[i] end;

                     if TimeOut = 0 then begin
                               rMsg := 'Poadavek na '+zapvyp+' Rel '+rt+'.';
                               Result := ctRelaySet
                              end else begin
                               rMsg := 'Poadavek na '+zapvyp+' Rel '+rt+' na dobu '+inttostr(Timeout)+' sekund.';
                               Result := ctRelayTimeOut;
                              end;



                except
                  TextOut('ERROR - Relay operating Cmd wrong syntax: -"'+Cmd+'".',mFailture);

                end;

        end else
     if Cmd='?' then if AlarmState=true then begin
                    Result := ctRequestInputs;
                    rMsg := 'Zjiuji poplach na vstupech 1-3 (Alarm aktivovn !).';
             end else begin
                    Result := ctRequestInputs;
                    rMsg := 'Zjiuji poplach na vstupech (Alarm nesepnut - dotaz je nejsp irelevantn).';
             end;

     if Cmd ='!' then begin
                    Result := ctRequestInputs;
                    rMsg := 'Zjiuji stav vstup 1-3...';
                 end;


     if Result = ctUnknown then TextOut('ERROR - Unknown Command "'+Cmd+'".',mFailture)
                           else begin

                               TextOut(rMsg,mCmd);
                               ////////////////////////////////////////////
                               if ComPort <> nil then ComPort.WriteStr(Cmd);
                               ////////////////////////////////////////////


                           end;


end else if Cmd='#fail' then TextOut('#fail - Chyba skladn pkazu (modul MakeCmd).',mFailture)
                        else TextOut('ERROR - Empty or unterminated command.',mFailture);




end;


function TRele.ProcessRespond(Cmd : string) : ResType;
var
rMsg : string;
begin

Result := rtUnknown;




  if (Cmd <> '') and (cmd[length(cmd)]='*') then begin

         try
// Preprocess
            case Cmd[1] of

                'r' : Result := rtAlarmRun;
                's' : Result := rtAlarmStop;

                '&' : Result := rtInputsOn;

                '*' : Result := rtNoAlert;
                '1','2','3','4','5','6' : Result := rtAlert;


                'A' : Result := rtInputsOff;
                'B' : Result := rtInputsOff;
                'C' : if length(Cmd)>1 then Result := rtRespondMode   // C1... odpoved na RcFg
                                       else Result := rtInputsOff;
                'D' : Result := rtInputsOff;
                'E' : Result := rtInputsOff;
                'F' : Result := rtInputsOff;

                'L' : Result := rtResetMode;
                'T' : if(length(Cmd)>1) and (Cmd[2]='E') then Result := rtButtonState // test
                                                         else Result := rtTimeout;     // t1e


                 else RMsg := 'ERROR - Unhandled CMD : "'+Cmd+'".';
            end;

             // Process

                case Result of

                  rtUnknown : RMsg := 'CHYBA - Neznm pkaz.';

                  rtInputsOn :
                                 if Length(Cmd)=5 then begin
                                       if Cmd[2] = '1' then Inputs[1] := true;
                                       if Cmd[2] = '0' then Inputs[1] := false;

                                       if Cmd[3] = '1' then Inputs[2] := true;
                                       if Cmd[3] = '0' then Inputs[2] := false;

                                       if Cmd[4] = '1' then Inputs[3] := true;
                                       if Cmd[4] = '0' then Inputs[3] := false;

                                       RMsg := 'Stav vstup naten.'

                                 end else RMsg := 'CHYBA- Nesprvn dlka pkazu - "'+Cmd+'".';

                  rtAlarmRun  :  if Cmd='running*' then begin
                                        AlarmState := true;
                                        RMsg := 'Alarm je sputn.'
                                end else RMsg := 'CHYBA - nepln odpov *Run* - "'+Cmd+'".';
                  rtAlarmStop :  if Cmd='stop*' then begin
                                        AlarmState := false;
                                        RMsg := 'Alarm byl vypnut.'
                                end else RMsg := 'CHYBA - nepln odpov *Stop* - "'+Cmd+'".';


                  rtNoAlert :  if Cmd='*' then begin
                                        AlertState := false;
                                        RMsg := 'Poplach nen aktivovn.'
                                end else RMsg := 'CHYBA - pli dlouh odpov *NoAlert* - "'+Cmd+'".';

                  rtAlert :  if StrToInt(Cmd) in [1..6] then begin
                                        AlertState := true;
                                        OnAlert(StrToInt(Cmd));
                                        RMsg := 'Poplach aktivovn sepnutm vstupu .'+Cmd;
                                end else RMsg := 'CHYBA - patn syntax odpovdi  *Alert* - "'+Cmd+'".';

                  rtTimeout : if Cmd[2] in ['1'..'6'] then begin
                                Relays[strtoint(Cmd[2])] := not Relays[strtoint(Cmd[2])];
                                RMsg := 'asova pepnul Rel .'+Cmd[2]+'.'
                             end else RMsg := 'CHYBA - Nesrozumiteln zprva asovae.';

                  rtButtonState: if Cmd='TEST=Y*' then begin
                                        AlarmState := true;
                                        RMsg := 'Alarm byl aktivovn run.'
                                end else if  Cmd='TEST=N*' then begin
                                        AlarmState := false;
                                        RMsg := 'Alarm byl run deaktivovn'
                                end else RMsg := 'CHYBA - nepln odpov *PushBtn* - "'+Cmd+'".';

                  rtResetMode: if Cmd='L=Y*' then begin
                                        ResetMode := true;
                                        RMsg := 'Aktivovn reim informovn o deaktivaci vstup.'
                                end else if  Cmd='L=N*' then begin
                                        ResetMode := true;
                                        RMsg := 'Reim informovn o deaktivaci vstup byl vypnut.'
                                end else RMsg := 'CHYBA - nepln odpov *ResetMode* - "'+Cmd+'".';

                  rtRespondMode: if Cmd='C1=1*' then begin
                                        ResetMode := true;
                                        RMsg := 'Aktivovn reim informovn o vypren asovae.'
                                end else if  Cmd='C1=0*' then begin
                                        ResetMode := true;
                                        RMsg := 'Reim informovn o vypren asovae byl vypnut.'
                                end else RMsg := 'CHYBA - nepln odpov *RespondMode* - "'+Cmd+'".';

                  rtInputsOff :  case Cmd[1] of
                                     'A' : begin
                                             Inputs[1] := false;
                                             RMsg := 'Vypnut vstupu .1';
                                           end;
                                     'B' : begin
                                             Inputs[2] := false;
                                             RMsg := 'Vypnut vstupu .2';
                                           end;
                                     'C' : begin
                                             Inputs[3] := false;
                                             RMsg := 'Vypnut vstupu .3';
                                           end;
                                     'D' : begin
                                             Inputs[4] := false;
                                             RMsg := 'Vypnut vstupu .4';
                                           end;
                                     'E' : begin
                                             Inputs[5] := false;
                                             RMsg := 'Vypnut vstupu .5';
                                           end;
                                     'F' : begin
                                             Inputs[6] := false;
                                             RMsg := 'Vypnut vstupu .6';
                                           end;
                                 end;

                 else RMsg := 'CHYBA - neoeten rozpoznan pkaz(nepravdpodobn).' end;







         except RMsg := 'ERROR - Error processing string "'+Cmd+'")';
         end;


  end else RMsg := 'ERROR - Empty or Unterminated Respond string Received.';



  TextOut(RMsg+ '('+Cmd+')',mRespond);





end;





procedure TRele.OnAlert(InputNumber : integer);
begin


{Alert} Messagebeep(0);

end;





function TRele.SwichRelays(R1,R2,R3,Delay : integer; TurnOnOff: boolean): string; // vrac "" kdy failne
var Str1: string;
begin

Str1 :='R';

try
   if (R1>0) and (R1<6) then Str1 := Str1 + inttostr(R1);
   if (R2>0) and (R2<6) then Str1 := Str1 + inttostr(R2);
   if (R3>0) and (R3<6) then Str1 := Str1 + inttostr(R3);

   if Str1 = 'R' then Exit;

   Str1 := Str1 + '=';

   if Delay > 0 then Str1 := Str1 + inttostr(Delay) +',';


   if TurnOnOff then Result := Str1 + '1s' else Result := Str1 + '0s'


 except
  Result := '#fail';
 end;

///////////////////////////
if ProcessCmd(Result)=ctUnknown then Result := '#fail';
///////////////////////////



end;





function TRele.RunAlarm: string;
begin

   Result := 'RUN=1s';
   ProcessCmd(Result);

end;


function TRele.StopAlarm: string;
begin

   Result := 'RUN=0s';
   ProcessCmd(Result);

end;


function TRele.CallOnInputStop(Call : boolean): string;
begin

if Call then Result := 'RESET=Ys' else Result := 'RESET=Ns';
   ProcessCmd(Result);


end;




function TRele.CallOnTimer(Call : boolean): string;
begin

if Call then Result := 'Rcfg1=1s' else Result := 'Rcfg1=0s';
   ProcessCmd(Result);

end;


function TRele.GetInputs : string;
begin
Result := '!';
ProcessCmd(Result);

end;

function TRele.GetArmedInputs : string;
begin
Result := '?';
ProcessCmd(Result);

end;



procedure TRele.ShowSetupDialog;
begin
  if ComPort <> nil then ComPort.ShowSetupDialog else TextOut('ERROR - No ComPort component link present.',mFailture)
end;



function TRele.ConnectOnPort(PortName : string) : boolean;
begin



  if ComPort <> nil then begin
       try
          ComPort.BaudRate := br4800;
          ComPort.DataBits := dbEight;
          ComPort.StopBits := sbOneStopBit;
          ComPort.Parity.Bits   := prNone;
          ComPort.Port := PortName;



        ComPort.Open;


       except Result := false; TextOut('CHYBA pi otvrn portu.',mFailture); End;






  end else begin
        TextOut('ERROR - No ComPort component link present.',mFailture);
        Result := false;
        end;


end;




end.
